local T, C, L, _ = unpack(select(2, ...))
if C.raidframe.plugins_aura_watch ~= true then return end

----------------------------------------------------------------------------------------
--	The best way to add or delete spell is to go at www.wowhead.com, search for a spell.
--	Example: Renew -> http://www.wowhead.com/spell=139
--	Take the number ID at the end of the URL, and add it to the list
----------------------------------------------------------------------------------------
T.RaidBuffs = {
	DRUID = {
		{774, "TOPRIGHT", {0.8, 0.4, 0.8}},					-- Rejuvenation
		{8936, "BOTTOMLEFT", {0.2, 0.8, 0.2}},				-- Regrowth
	},
	PALADIN = {
		{1022, "BOTTOMRIGHT", {0.2, 0.2, 1}, true},			-- Blessing of Protection
		{1044, "BOTTOMRIGHT", {0.89, 0.45, 0}, true},		-- Blessing of Freedom
		{6940, "BOTTOMRIGHT", {0.89, 0.1, 0.1}, true},		-- Blessing of Sacrifice
	},
	PRIEST = {
		{139, "BOTTOMLEFT", {0.4, 0.7, 0.2}}, 				-- Renew
		{17, "TOPLEFT", {0.81, 0.85, 0.1}, true},			-- Power Word: Shield
		{6788, "TOPRIGHT", {1, 0, 0}, true},				-- Weakened Soul
		{10060, "RIGHT", {0.89, 0.1, 0.1}},					-- Power Infusion
	},
	ROGUE = {
	},
	SHAMAN = {
		{29203, "BOTTOMRIGHT", {0.7, 0.4, 0}},				-- Healing Way (Change Color?)
		{16177, "TOPLEFT", {0.4, 0.7, 0.2}},				-- Ancestral Fortitude
	},
	WARLOCK = {
		{20707, "TOPRIGHT", {0.7, 0.32, 0.75}},				-- Soulstone
	},
	ALL = {
		{23333, "LEFT", {1, 0, 0}, true}, 					-- Warsong flag, Horde
		{23335, "LEFT", {0, 0, 1}, true},					-- Warsong flag, Alliance
		{2893, "RIGHT", {0, 1, 0}, true}, 					-- Abolish Poison
		{26470, "RIGHT", {0.8, 0.2, 0}, true},				-- Persistent Shield [Scarab Brooch]
	},
}

T.RaidBuffsIgnore = {
	--[spellID] = true,			-- Spell name
}

local function SpellName(id)
	local name = GetSpellInfo(id)
	if name then
		return name
	else
		print("|cffff0000WARNING: spell ID ["..tostring(id).."] no longer exists! Report this to EsreverWoW.|r")
		return "Empty"
	end
end

T.RaidDebuffs = {
--[[-----------------------------------------------------------------
-- Classic Raid
-----------------------------------------------------------------
	-- 奥妮克希亚的巢穴
	[SpellName(18431)] = 3,		-- 低沉咆哮
	-- 熔火之心
	[SpellName(19703)] = 3,		-- 奥西弗隆的诅咒
	[SpellName(19408)] = 3,		-- 恐慌
	[SpellName(19716)] = 3,		-- 基赫纳斯的诅咒
	[SpellName(20277)] = 3,		-- 拉格纳罗斯之拳
	[SpellName(20475)] = 3,		-- 活化炸弹
	[SpellName(19695)] = 3,		-- 地狱火
	[SpellName(19659)] = 3,		-- 点燃法力
	[SpellName(19714)] = 3,		-- 衰减魔法
	[SpellName(19713)] = 3,		-- 沙斯拉尔的诅咒
	-- 黑翼之巢
	--[SpellName(23023)] = 3,		-- 燃烧
	[SpellName(18173)] = 3,		-- 燃烧刺激
	[SpellName(24573)] = 3,		-- 致死打击
	[SpellName(23340)] = 3,		-- 埃博诺克之影
	[SpellName(22274)] = 3,		-- 强效变形术
	[SpellName(23341)] = 3,		-- 烈焰打击
	[SpellName(23170)] = 3,		-- 青铜
	[SpellName(22687)] = 3,		-- 暗影迷雾
	[SpellName(23154)] = 3,		-- 龙血之痛：黑（诅咒）
	[SpellName(23153)] = 3,		-- 龙血之痛：蓝（魔法）
	[SpellName(23155)] = 3,		-- 龙血之痛：红（疾病）
	[SpellName(23169)] = 3,		-- 龙血之痛：绿（中毒）
	-- 祖尔格拉布
	[SpellName(23860)] = 3,		-- 神圣之火
	[SpellName(22884)] = 3,		-- 心灵尖啸
	[SpellName(23918)] = 3,		-- 音爆
	[SpellName(24111)] = 3,		-- 腐蚀之毒
	[SpellName(21060)] = 3,		-- 致盲
	[SpellName(24328)] = 3,		-- 堕落之血
	[SpellName(16856)] = 3,		-- 致死打击
	[SpellName(24664)] = 3,		-- 睡眠
	[SpellName(17172)] = 3,		-- 妖术
	[SpellName(24306)] = 3,		-- 金度的欺骗
	[SpellName(24099)] = 3,		-- 毒箭之雨
	-- 安其拉废墟
	[SpellName(25646)] = 3,		-- 重伤
	[SpellName(25471)] = 3,		-- 攻击命令
	[SpellName(96)] = 3,		-- 肢解
	[SpellName(25725)] = 3,		-- 麻痹
	[SpellName(25189)] = 3,		-- 包围之风
	[SpellName(22997)] = 3,		-- 瘟疫
	-- 安其拉神殿
	[SpellName(785)] = 3,		-- 充实
	[SpellName(26580)] = 3,		-- 恐惧
	[SpellName(26050)] = 3,		-- 酸性喷射
	[SpellName(26180)] = 3,		-- 翼龙钉刺
	[SpellName(26053)] = 3,		-- 致命剧毒
	[SpellName(26613)] = 3,		-- 重压打击
	[SpellName(26029)] = 3,		-- 黑暗闪耀
	[SpellName(26476)] = 3,		-- 消化酸液（克苏恩胃内）
	[SpellName(26556)] = 3,		-- 瘟疫
	[SpellName(25991)] = 3,		-- 毒箭之雨（维希度斯）
	-- 纳克萨玛斯
	[SpellName(28350)] = 3,		-- 黑暗之雾*小怪
	[SpellName(28440)] = 3,		-- 幽影之雾*小怪
	[SpellName(28431)] = 3,		-- 毒性充能*小怪
	[SpellName(27993)] = 3,		-- 践踏*小怪
	[SpellName(28732)] = 3,		-- 黑女巫的拥抱*法琳娜
	[SpellName(28796)] = 3,		-- 毒箭之雨*法琳娜
	[SpellName(28776)] = 3,		-- 死灵之毒*迈克斯纳
	[SpellName(28622)] = 3,		-- 蛛网裹体*迈克斯纳
	[SpellName(29484)] = 3,		-- 蛛网喷射*迈克斯纳
	[SpellName(29213)] = 3,		-- 瘟疫使者的诅咒
	[SpellName(29212)] = 3,		-- 残废术*诺斯
	[SpellName(29998)] = 3,		-- 衰弱瘟疫*希尔盖
	--[SpellName(29204)] = 3,		-- 必然的厄运*洛欧塞布
	--[SpellName(28832)] = 3,		-- 库尔塔兹印记*
	--[SpellName(28833)] = 3,		-- 布劳缪克丝印记*
	--[SpellName(28834)] = 3,		-- 莫格莱尼印记*
	--[SpellName(28835)] = 3,		-- 瑟里耶克印记
	[SpellName(28169)] = 3,		-- 变异注射
	--[SpellName(28062)] = 3,		-- 正能量*塔迪乌斯
	--[SpellName(28085)] = 3,		-- 负能量*塔迪乌斯
	[SpellName(28542)] = 3,		-- 生命吸取*萨菲隆
	[SpellName(28522)] = 3,		-- 寒冰箭*萨菲隆
	[SpellName(27808)] = 3,		-- 冰霜冲击
	[SpellName(28410)] = 3,		-- 克尔苏加德的锁链
	[SpellName(27819)] = 3,		-- 自爆法力
	--[SpellName(29325)] = 3,		-- 酸性箭雨
	-- 黑色深渊
	[SpellName(246)] = 3,		-- 减速术
	[SpellName(6533)] = 3,		-- 投网
	[SpellName(8399)] = 3,		-- 催眠
	-- 黑石深渊
	[SpellName(13704)] = 3,		-- 心灵尖啸
	-- 死矿
	[SpellName(6304)] = 3,		-- 拉克佐猛击
	[SpellName(12097)] = 3,		-- 刺穿护甲
	[SpellName(6713)] = 3,		-- 缴械
	[SpellName(5213)] = 3,		-- 熔铁之水
	[SpellName(5208)] = 3,		-- 毒性鱼叉
	-- 玛拉顿
	[SpellName(7964)] = 3,		-- 烟雾弹
	[SpellName(21869)] = 3,		-- 憎恨凝视
	-- 怒焰裂谷
	[SpellName(744)] = 3,		-- 毒药
	[SpellName(18267)] = 3,		-- 虚弱诅咒
	[SpellName(20800)] = 3,		-- 献祭
	-- 剃刀高地
	[SpellName(12255)] = 3,		-- 图特卡什的诅咒
	[SpellName(12252)] = 3,		-- 撒网
	[SpellName(7645)] = 3,		-- 统御意志
	[SpellName(12946)] = 3,		-- 腐烂恶臭
	-- 剃刀沼泽
	[SpellName(14515)] = 3,		-- 统御意志
	-- 血色修道院
	[SpellName(9034)] = 3,		-- 献祭
	[SpellName(8814)] = 3,		-- 烈焰尖刺
	[SpellName(8988)] = 3,		-- 沉默
	[SpellName(9256)] = 3,		-- 深度睡眠
	[SpellName(8282)] = 3,		-- 血之诅咒
	-- 影牙城堡
	[SpellName(7068)] = 3,		-- 暗影迷雾
	[SpellName(7125)] = 3,		-- 毒性唾液
	[SpellName(7621)] = 3,		-- 阿鲁高的诅咒
	-- 斯塔索姆
	[SpellName(16798)] = 3,		-- 催眠曲
	[SpellName(12734)] = 3,		-- 大地粉碎
	[SpellName(17293)] = 3,		-- 燃烧之风
	[SpellName(17405)] = 3,		-- 支配
	[SpellName(16867)] = 3,		-- 女妖诅咒
	[SpellName(6016)] = 3,		-- 刺穿护甲
	[SpellName(16869)] = 3,		-- 寒冰之墓
	[SpellName(17307)] = 3,		-- 击昏
	-- 沉默的神庙
	[SpellName(12889)] = 3,		-- 语言诅咒
	[SpellName(12888)] = 3,		-- 导致疯狂
	[SpellName(12479)] = 3,		-- 伽玛兰的妖术
	[SpellName(12493)] = 3,		-- 虚弱诅咒
	[SpellName(12890)] = 3,		-- 深度睡眠
	[SpellName(24375)] = 3,		-- 战争践踏
	-- 奥达曼
	[SpellName(3356)] = 3,		-- 烈焰鞭笞
	[SpellName(6524)] = 3,		-- 大地震颤
	-- 哀嚎洞穴
	[SpellName(8040)] = 3,		-- 德鲁伊的睡眠
	[SpellName(8142)] = 3,		-- 缠绕之藤
	[SpellName(7967)] = 3,		-- 纳拉雷克斯的梦魇
	[SpellName(7399)] = 3,		-- 恐吓
	[SpellName(8150)] = 3,		-- 雷霆震颤
	-- 祖尔法拉克
	[SpellName(11836)] = 3,		-- 冰霜凝固
	-- 世界BOSS
	[SpellName(21056)] = 3,		-- 卡扎克的印记
	[SpellName(24814)] = 3,		-- 渗漏之雾
]]}

-----------------------------------------------------------------
-- PvP
-----------------------------------------------------------------
if C.raidframe.plugins_pvp_debuffs == true then
	T.PvPDebuffs = {
		-- Druid
		[SpellName(5211)] = 3,		-- Bash
		[SpellName(16922)] = 3,		-- Celestial Focus
		[SpellName(339)] = 3,		-- Entangling Roots
		[SpellName(19975)] = 3,		-- Entangling Roots (Nature's Grasp)
		[SpellName(19675)] = 3,		-- Feral Charge Effect
		[SpellName(2637)] = 3,		-- Hibernate
		[SpellName(22570)] = 3,		-- Mangle
		[SpellName(9005)] = 3,		-- Pounce
		-- Hunter
		[SpellName(19306)] = 3,		-- Counterattack
		[SpellName(19185)] = 3,		-- Entrapment
		[SpellName(3355)] = 3,		-- Freezing Trap
		[SpellName(2637)] = 3,		-- Hibernate
		[SpellName(19410)] = 3,		-- Improved Concussive Shot
		[SpellName(19229)] = 3,		-- Improved Wing Clip
		[SpellName(24394)] = 3,		-- Intimidation
		[SpellName(19503)] = 3,		-- Scatter Shot
		[SpellName(19386)] = 3,		-- Wyvern Sting
		-- Mage
		[SpellName(12494)] = 3,		-- Frostbite
		[SpellName(122)] = 3,		-- Frost Nova
		[SpellName(12355)] = 3,		-- Impact
		[SpellName(118)] = 3,		-- Polymorph
		[SpellName(28272)] = 3,		-- Polymorph: Pig
		[SpellName(28271)] = 3,		-- Polymorph: Turtle
		[SpellName(18469)] = 3,		-- Silenced - Improved Counterspell
		-- Paladin
		[SpellName(853)] = 3,		-- Hammer of Justice
		[SpellName(20066)] = 3,		-- Repentance
		[SpellName(20170)] = 3,		-- Stun (Seal of Justice Proc)
		[SpellName(2878)] = 3,		-- Turn Undead
		-- Priest
		[SpellName(15269)] = 3,		-- Blackout
		[SpellName(605)] = 3,		-- Mind Control
		[SpellName(8122)] = 3,		-- Psychic Scream
		[SpellName(9484)] = 3,		-- Shackle Undead
		[SpellName(15487)] = 3,		-- Silence
		-- Rogue
		[SpellName(2094)] = 3,		-- Blind
		[SpellName(1833)] = 3,		-- Cheap Shot
		[SpellName(1776)] = 3,		-- Gouge
		[SpellName(408)] = 3,		-- Kidney Shot
		[SpellName(14251)] = 3,		-- Riposte
		[SpellName(6770)] = 3,		-- Sap
		[SpellName(18425)] = 3,		-- Silenced - Improved Kick
		-- Warlock
		[SpellName(6789)] = 3,		-- Death Coil
		[SpellName(5782)] = 3,		-- Fear
		[SpellName(5484)] = 3,		-- Howl of Terror
		[SpellName(18093)] = 3,		-- Pyroclasm
		[SpellName(6358)] = 3,		-- Seduction (Succubus)
		[SpellName(24259)] = 3,		-- Spell Lock (Felhunter)
		-- Warrior
		[SpellName(7922)] = 3,		-- Charge Stun
		[SpellName(12809)] = 3,		-- Concussion Blow
		[SpellName(676)] = 3,		-- Disarm
		[SpellName(23694)] = 3,		-- Improved Hamstring
		[SpellName(5246)] = 3,		-- Intimidating Shout
		[SpellName(20253)] = 3,		-- Intercept Stun
		[SpellName(12798)] = 3,		-- Revenge Stun
		[SpellName(18498)] = 3,		-- Shield Bash - Silenced
		-- Racial
		[SpellName(20549)] = 3,		-- War Stomp
		-- Other
		[SpellName(5530)] = 3,		-- Mace Specialization
	}

	for spell, prio in pairs(T.PvPDebuffs) do
		T.RaidDebuffs[spell] = prio
	end
end

T.RaidDebuffsReverse = {
	--[spellID] = true,			-- Spell name
}

T.RaidDebuffsIgnore = {
	--[spellID] = true,			-- Spell name
}

for _, spell in pairs(C.raidframe.plugins_aura_watch_list) do
	T.RaidDebuffs[SpellName(spell)] = 3
end

if #C.raidframe.plugins_aura_watch_list == 0 then
	if C.options.raidframe and C.options.raidframe.plugins_aura_watch_list then
		C.options.raidframe.plugins_aura_watch_list = nil
	end
end